
global bugsFound = 0
global NeoDexErrors

fn InitiateErrorCategory name description =
(
	DictionaryAddEntryData NeoDexErrors name #(description, Dictionary ())
)

fn reportError name object value =
(
	local err = DictionaryGetEntryData NeoDexErrors name
	local dictio = err[1][2]
	DictionaryAddEntryData dictio  object value
	bugsFound += 1
)

fn errorReporterHasErrors = bugsFound != 0

fn printError name =
(
	fn removeUndefineds arr =
	(
		result = #()
		if arr != undefined then for a in arr where (a != undefined) do append result a
		result
	)
	fn tmp array =
	(
		if (array[1] != undefined) then
		(
			local result =  (array[1] as string)
			for i = 2 to array.count do result = result +  ", " + (array[i] as string)
			result
		) else ""
	)
	local err = DictionaryGetEntryData NeoDexErrors name
	local description = err[1][1]
	local dictio = err[1][2]
	local data = DictionaryOutputData dictio
	if (data.count == 0) then return OK
	format "//%" "/////////////////////////////////////////////////////////////////////////////////\n" to:listener
	format "// %" (name + "\n")
	format "//%" "/////////////////////////////////////////////////////////////////////////////////\n" to:listener
	format "//%" (description +"\n")
	format "//%" "/////////////////////////////////////////////////////////////////////////////////\n" to:listener
	for i = 1 to data.count do
	(
		local d = #(data[i][1],data[i][2])
		local info = removeUndefineds d[2]
		if (info == undefined or info.count == 0) then
			format "// %" ((d[1] as string) + "\n") to:listener
		else
		(
			format "// %" ((d[1] as string) + ": " ) to:listener
			format "(%" ((tmp info) + ")\n") to:listener
		)
	)
	format "//%" "/////////////////////////////////////////////////////////////////////////////////\n" to:listener
)

fn promptErrorReporter =
(
	if (not gmax) then clearListener ()
	printError "No Sequences"
	printError "Material"
	printError "No Unwrap"
	printError "Bad Unwrap"
	printError "Bad Skinning"
	printError "Weights"
	printError "StartEndKeys"
	printError "TCB"
)

fn InitiateErrorReporter =
(
	bugsFound = 0
	NeoDexErrors = Dictionary ()
	InitiateErrorCategory "TCB" " The next objects have conflicting rotation keys at the showed time\n// To fix it add a key between the mentioned key and the key before, or use the NeoDex Animation Tools"
	InitiateErrorCategory "Material" " The next objects have non Warcraft 3 materials or\n// Composites that have non Warcraft 3 materials."
	InitiateErrorCategory "StartEndKeys" " The next objects don't have start and end keys on the mentioned animations."
	InitiateErrorCategory "No Unwrap" " The next objects aren't unwrapped or have vertices without unwrap,\n// no unwrap is exported into them."
	InitiateErrorCategory "Bad Unwrap" " The next objects have some vertices without unwrap.\n// Neodex will try to assign them an unwrap."
	InitiateErrorCategory "Weights" " The next objects have unbalanced weights,\n// they may be wrongly animated."
	InitiateErrorCategory "Bad Skinning" " The next objects have skin modifiers with some unskinned vertices,\n// The skin modifier will be ignored until fixed."
	InitiateErrorCategory "No Sequences" " No sequence data was found on the scene (Track View -> Objects -> NoteTrack).\n// This warnning may also show if the data is not formated correctly"
)