
global NeoDexProgressLabel
global NeoDexProgressBar
global NeoDexProgressLevels
global NeoDexProgressLevelsPart
global NeoDexProgressPreValue = 0.0
global NeoDexProgressCurrentLevel = 0

fn progressInitiate label bar =
(
	NeoDexProgressPreValue = 0.0
	NeoDexProgressLabel = label
	NeoDexProgressBar = bar
	bar.value = 0.0
	label.caption = "Initiated"
	NeoDexProgressLevels = #(100.0)
	NeoDexProgressLevelsPart = #(100.0)
	NeoDexProgressLevelsSaved = #(0.0)
	NeoDexProgressCurrentLevel = 1
)

fn progressDownLevel amount items =
(
	local lastLevel = NeoDexProgressLevels[NeoDexProgressCurrentLevel] as float
	local newLevel = (lastLevel*amount)/100.0
	append NeoDexProgressLevels newLevel
	append NeoDexProgressLevelsPart (newLevel/(items as float))
	NeoDexProgressCurrentLevel += 1
)

fn progressShowItem text =
(
	NeoDexProgressLabel.caption = text
	NeoDexProgressPreValue = NeoDexProgressPreValue + NeoDexProgressLevelsPart[NeoDexProgressCurrentLevel]
	NeoDexProgressBar.value = NeoDexProgressPreValue
)

fn progressUpdateItem text =
(
	NeoDexProgressLabel.caption = text
)

fn progressUpLevel =
(
	local lastLevel = NeoDexProgressLevels[NeoDexProgressCurrentLevel]
	deleteItem NeoDexProgressLevels NeoDexProgressCurrentLevel
	deleteItem NeoDexProgressLevelsPart NeoDexProgressCurrentLevel
	NeoDexProgressCurrentLevel -= 1
)

fn progressFinalize =
(
	NeoDexProgressLabel.caption = "Done"
	NeoDexProgressBar.value = 100
)