
-- Needs UtilitiesFunctions

fn cleanMatrices geo =
(
	local tmp = ArrayMakeUnique geo.matrixIndices
	sort tmp
	local newMatrices = #()
	local tmp2 = #()
	local i = 0
	local indices = geo.matrixIndices
	for t in tmp do
	(
		append newMatrices geo.matrices[t+1]
		tmp2[t+1] = i
		i += 1
	)
	for i = 1 to indices.count do
		indices[i] = tmp2[indices[i] + 1]
	geo.matrices = newMatrices
	OK
)

-- this is better than using an octree
fn GatherBoundingVertices geo1 geo2 thresshold =
(
	thresshold = thresshold*0.5
	local min2 = geo2.mesh.min - thresshold
	local max2 = geo2.mesh.max + thresshold
	local result = #()
	for i = 1 to geo1.vertices.count do
		if (IsPointInBounds min2 max2 geo1.vertices[i]) then
			append result i
	result
)

-- This function is used for AT skinning
fn applySyntheticSkin geo1 geo2 thresshold fixNormals =
(
	fn mergeMatrices array array2 =
	(
		local result = deepCopy array
		join result array2
		result = ArrayMakeUnique result
		sort result
		result
	)
	fn addNewMatrix &array a =
	(
		local result = ArrayFindItem array a
		if (result == 0) then
		(
			append array a
			result = array.count 
		)
		(result - 1)
	)
	vertices1 = GatherBoundingVertices geo1 geo2 thresshold
	vertices2 = GatherBoundingVertices geo2 geo1 thresshold
	ts = thresshold*0.5
	fn tmp p1 t = ((abs p1.x) < t and (abs p1.y) < t and (abs p1.z) < t)
	for i = 1 to vertices1.count do
	(
		local v = vertices1[i]
		for j = 1 to vertices2.count do
		(
			local w = vertices2[j]
			if (tmp (geo1.vertices[v] - geo2.vertices[w]) ts) then
			(
				local matrix = mergeMatrices (geo2.matrices[geo2.matrixIndices[w]+1])  (geo1.matrices[geo1.matrixIndices[v]+1])
				geo1.matrixindices[v] = addNewMatrix geo1.matrices matrix
				geo2.matrixindices[w] = addNewMatrix geo2.matrices matrix
				if fixNormals then
				(
					local newNormal = (geo1.normals[v] + geo2.normals[w])*0.5
					geo1.normals[v] = newNormal
					geo2.normals[w] = newNormal
				)
			)
		)
	)
	cleanMatrices geo1
	cleanMatrices geo2
)