
struct Wc3Extent (
	minExtent,
	maxExtent,
	bound
)

struct Wc3Sequence (
	name, 
	startTime, 
	endTime, 
	loop, 
	rarity, 
	movespeed,
	extents,
	ex
)

struct Wc3Texture (
	path,
	replaceableId,
	wrapWidth,
	wrapHeight,
	id,
	ex
)

struct Wc3Layer (
	filtermode, 
	alpha, 
	color, 
	twosided, 
	unshaded, 
	unfogged, 
	nodephtest, 
	nodephset, 
	unselectable,
	unknown1 = false,
	unknown2 = false,
	textures,
	coordId,
	tvertexid,
	ex
)

struct Wc3Material (
	maxObj,
	layers,
	id,
	tvertexId,
	ex
)

struct Wc3TvertexAnim (
	transformation,
	id,
	ex
)

struct Wc3Geoset (
	mesh = undefined,					-- mesh object
	vertices = #(),					-- array of point3s
	normals = #(),
	tvertices = #(),
	matrixindices = #(),
	faces = #(),
	matrices = #(),
	material = undefined,
	id = 0,
	geosetAnimId = undefined,
	mainExtents,
	extents = #(),
	numUVWmaps = 1,
	unselectable = false,
	visObj,
	ex
)

struct MaxGeoset (
	mesh = undefined,					-- mesh object
	vertices = #(),					-- array of point3s
	normals = #(),
	tvertices = #(),
	matrixindices = #(),
	faces = #(),
	tvfaces = #(),
	matrices = #(),
	material = undefined,
	id = 0,
	geosetAnimId = undefined,
	numUVWmaps = 1,
	ex
)

struct Wc3GeosetAnim (
	dropShadow,
	usesColor,
	alpha,
	color,
	geoset,
	id,
	ex
)

struct MDLObject (
	maxObj = undefined,
	name,
	objId,
	pivot,
	parent,
	billboardType = #None,
	cameraAnchored = false,
	transformations,
	dontInheriteTranslation = false,
	dontInheriteRotation = false,
	dontInheriteScale = false,
	sub = undefined,
	deleted = undefined
)

struct Wc3Bone (
	mdlObj,
	geosets = #(),
	geosetAnimId,
	type = #Wc3Bone,
	ex
)

struct Wc3Helper (
	mdlObj,
	type = #Wc3Helper,
	ex
)

struct Wc3Light (
	mdlObj,
	lightType,
	attenuationStart,
	attenuationEnd,
	intensity,
	color,
	ambIntensity,
	ambColor,
	visibility,
	type = #Wc3Light,
	ex
)

struct Wc3Attachment (
	mdlObj,
	name,
	attachmentId,
	outPath,
	visibility,
	type = #Wc3Attachment,
	ex
)

struct Wc3Camera (
	name,
	pivot,
	transformations,
	fieldOfView,
	farClip,
	nearClip,
	targetPos,
	targetTransformations,
	rotation,
	ex
)

struct Wc3ParticleEmitter (
	mdlObj,
	emissionType = #Mdl,
	emissionRate,
	gravity,
	longitude,
	latitude,
	visibility,
	lifespan,
	initVelocity,
	path,
	type = #Wc3ParticleEmitter,
	ex
)

struct Wc3ParticleEmitter2 (
	mdlObj,
	sortPrimesFarZ,
	unshaded,
	lineEmitter,
	unfogged,
	modelSpace,
	xyQuad,
	speed,
	variation,
	latitude,
	gravity,
	visibility,
	squirt,
	lifeSpan,
	emissionRate,
	width,
	length,
	filtermode,
	rows,
	columns,
	particleType,
	tailLength,
	time,
	startColor,
	midColor,
	endColor,
	alpha,
	scaling,
	lifeSpanUVAnim,
	decayUVAnim,
	TailUVAnim,
	TailDecayUVAnim,
	texture,
	replaceableId,
	priorityPlane,
	type = #Wc3ParticleEmitter2,
	ex
)

struct Wc3RibbonEmitter (
	mdlObj,
	heightAbove,
	heightBelow,
	alpha,
	color,
	textureSlot,
	visibility,
	emissionRate,
	lifeSpan,
	gravity,
	rows,
	columns,
	material,
	type = #Wc3RibbonEmitter,
	ex
)

struct Wc3Event (
	mdlObj,
	eventTrack,
	type = #Wc3Event,
	ex
)

struct Wc3CollisionShape (
	mdlObj,
	shape = undefined,
	vertices,
	boundsRadius,
	type = #Wc3CollisionShape,
	ex
)

struct Wc3Model (
	version,
	name = undefined,
	extents,
	globalSequences,
	sequences,
	textures,
	materials,
	tvertexAnims,
	geosets,
	geosetAnims,
	bones,
	lights,
	helpers,
	attachments,
	particleEmitters1,
	particleEmitters2,
	ribbonEmitters,
	events,
	cameras,
	CollisionShapes,
	ex
)
