
macroscript NeoDex_Exporter
    buttonText:"Export Wc3 Model"
	category:"NeoDex Toolkit"
    internalCategory:"Import/Export" 
(
    local neoDexVersion = ".65"
	-- Includes
	include "NeoDexModules\\ProgressUtility.ms"
	include "NeoDexModules\\Wc3Model.ms"
	include "NeoDexModules\\UtilityFunctions.ms"
	include "NeoDexModules\\GeometryUtilities.ms"
	include "NeoDexModules\\NeoDexIO.ms"
	include "NeoDexModules\\ErrorReporter.ms"
	include "NeoDexModules\\Wc3Animation.ms"
	include "NeoDexModules\\NeoDexSceneParser.ms"
	include "NeoDexModules\\NeoDexOptimize.ms"
	include "NeoDexModules\\NeoDexMDLWritter.ms"
	include "NeoDexModules\\NeoDexMDXWritter.ms"
	-- end Includes
	rollout mainroll "Export Settings" width:225 height:547
	(
		button ExpMDL "Export" pos:[53,509] width:105 height:29
		edittext edt1 "" pos:[72,19] width:134 height:18
		label lbl1 "Model Name:" pos:[10,22] width:67 height:18
		GroupBox grp1 "Export Mode" pos:[12,52] width:203 height:64
		radiobuttons rdo1 "" pos:[21,75] width:96 height:32 labels:#("Standard Mode", "Debug Mode") default:1 columns:1
		GroupBox grp2 "Progress" pos:[12,123] width:203 height:72
		progressBar pb1 "" pos:[23,153] width:180 height:11 value:0 color:(color 30 10 190)
		label lbl2 "Idle" pos:[23,137] width:170 height:14
		GroupBox grp3 "Extra options" pos:[12,203] width:202 height:158
		checkbox chk1 "Merge similar meshes" pos:[56,240] width:128 height:18 checked:true
		radiobuttons rdo3 "Extents Calculation" pos:[27,393] width:125 height:46 labels:#("Animation Dependant", "Global") columns:1
		slider sld1 "Extents Precision" pos:[27,448] width:171 height:44 range:[0,10,6] type:#integer orient:#horizontal
		button btn4 "?" pos:[166,400] width:20 height:19
		checkbox chk2 "Fix normals" pos:[57,286] width:79 height:18 enabled:true checked:true
		GroupBox grp4 "Extents Calculation" pos:[13,372] width:201 height:126
		label lbl3 "Optimizations:" pos:[27,221] width:64 height:13
		label lbl4 "AT Skinning:" pos:[27,266] width:63 height:14
		spinner spn1 "" pos:[120,313] width:45 height:16 range:[0,100,0.1] type:#float scale:0.025
		label lbl5 "Thresshold:" pos:[57,313] width:58 height:17
		button btn3 "?" pos:[144,285] width:23 height:17
		label lbl6 "" pos:[96,170] width:110 height:17
		checkbox chk3 "Export Smoothgroups" pos:[57,338] width:120 height:17 checked:true
		button btn5 "?" pos:[183,339] width:19 height:18
		on ExpMDL pressed do
		(
			local inside = true
			local outfile_name
			local usesMdx = true
			if (not gmax) then
			(
				outfile_name = getSaveFileName types:"MDX File (*.mdx)|*.mdx|MDL File (*.mdl)|*.mdl|All Files (*.*)|*.*|" --"MDL File (*.mdl)|*.mdl|All Files (*.*)|*.*|"
				if outfile_name != undefined then
					if (substring outfile_name (outfile_name.count-2) 3) == "mdl" then usesMdx = false
				inside = (outfile_name != undefined)
			)
			if inside then
			(
				lbl6.caption = ""
				local time1 = timestamp ()
				progressInitiate lbl2 pb1
				local sel = #()
				for s in selection do append sel s
				len = animationRange
				sliderTmp = sliderTime
				animationRange = interval 0f 100f
				sliderTime = 0f
				case (rdo1.state) of
				(
					1:
					(
						local noError = true
						InitiateErrorReporter ()
						DisableSceneRedraw ()
						progressDownLevel 70 1
						try
							model = ParseScene \
								mergeGeosets:chk1.checked extentsCalculation:rdo1.state extentsPrecision:sld1.value \
								ATFixNormals:chk2.checked ATThresshold:spn1.value faceGroups:chk3.checked
						catch
						(
							messageBox "Export Failed: Error while parsing the scene\n Please open the listener and report the bug"
							if (not gmax) then format "*** % ***\n" (getCurrentException()) to:listener
							if resumeEditing != undefined then resumeEditing ()
							noError = false
						)
						progressUpLevel ()
						if noError then
						(
							progressDownLevel 30 1
							model.name = edt1.text
							try
							(
								progressUpdateItem "Optimizing Model..."
								optimizeExportModel model
								if (not gmax) then
									if usesMdx then
										OutputMDX model outfile_name
									else
										OutputMDL model outfile_name
								else
									OutputMDLGmax model
							)
							catch
							(
								messageBox "Export Failed: Error while writting the mdl file\n Please open the listener and report the bug"
								if (not gmax) then format "*** % ***\n" (getCurrentException()) to:listener
								noError = false
							)
							progressUpLevel ()
							progressFinalize ()
						)
						EnableSceneRedraw ()
						if noError then
						(
							lbl6.caption = "Total Time: " + (((timestamp () -time1)/1000.0) as string) + "s."
							messageBox "Export Successful"
							if gmax then messageBox "Now run YAGG Gmax Grabber and grab the scene.\n Or cut & paste from the listener."
							if (errorReporterHasErrors ()) then
								if (queryBox "Some warnnings were found during the exporting process.\n Would you like to see them?") then
								(
									try
									(
										promptErrorReporter ()
										messageBox \
											"The warnnings have been printed in the listener.\n You can find it in utilities->MaxScript or by typing F11."
									)
									catch
									(
										messageBox "Warnning Propmt Failed: Error while propmting warnnings"
										if (not gmax) then format "*** % ***\n" (getCurrentException()) to:listener
									)
								)
						)
						else
							messageBox "Export Failed, try the debug mode to generate the log."
					)
					default:
					(
						InitiateErrorReporter ()
						progressDownLevel 70 1
						model = ParseScene \
								mergeGeosets:chk1.checked extentsCalculation:rdo1.state extentsPrecision:sld1.value \
								ATFixNormals:chk2.checked ATThresshold:spn1.value faceGroups:chk3.checked
						progressUpLevel ()
						model.name = edt1.text
						gc ()
						progressDownLevel 30 1
						if (not gmax) then
							if usesMdx then
								OutputMDX model outfile_name
							else
								OutputMDL model outfile_name
						else
							OutputMDLGmax model
						progressUpLevel ()
						promptErrorReporter ()
					)
				)
				animationRange = len
				sliderTime = sliderTmp
				deselect selection
				select sel
				lbl2.caption = "Idle"
				pb1.value = 0.0
			)
		)
		on btn4 pressed do
		(
			messageBox (
				"Extents are the information which tells the game how and where is your model selectable." + \
				" NeoDex calculates them by meseuring your model at different times. This process can be very expensive" + \
				" and may take a lot of time, depending on how much precision you want and how many meshes your model has.\n\n" + \
				"Animation Specific will make neodex calculate extents depending on how long each animation is. Global will ignore it and use" + \
				" the same precision over all the animations."
			)
		)
		on btn3 pressed do
		(
			messageBox (
				"Fixing normals, will recalculate normals for connected vertices, don't use this if you care about smoothing groups.\n\n" + \
				"Thresshold is the maximun distance for connecting vertices."
			)
		)
		on btn5 pressed do
		(
			messageBox (
				"Calculating smoothgroups will produce bigger file sizes since the meshes must be partitioned for wc3's format.\n\n" + \
				"This option will also make exporting take a little more time."
			)
		)
	)
	
	rollout creditsRoll "Credits" width:162 height:176
	(
		label lbl1 "Author: BlinkBoy" pos:[23,22] width:111 height:18
		label lbl2 "Contributers: Republicola (author of original dexporter), Igni (Implemented Bipped Support and some fixes)" pos:[11,41] width:138 height:62
		label lbl3 "Beta Testers: Adiktuz, BallisticTerrain, Manoo, skrab, Talavaj" pos:[8,105] width:122 height:46
		groupBox grp1 "" pos:[3,4] width:152 height:164
	)
	
	Main = newrolloutfloater ("NeoDex Exporter 2" + neoDexVersion) 250 560
	addrollout mainroll Main
	addrollout creditsRoll Main
	if (maxFileName != "") then
		mainroll.edt1.text = (substring maxFileName 1 (maxFileName.count-4))
	else
		mainroll.edt1.text = "Just Another Model"
)