--This script has been programmed by Fernando A Sahmkow aka BlinkBoy/BlinkHawk

--I would like to credit Fred Moreau for his FK2IKSnap, it helped me fix a problem with mine
--concerning enables effects and finding the reason which caused mine to unstabilize(scenedrawing)
macroscript NeoDex_IK_Snapper
    buttonText:"IK Snapper" 
    category:"NeoDex Toolkit"
	internalCategory:"Converters" 
(
    local IKSnapperVersion = "1.0"
	struct IKObject(obj, controller, bones, keys, enables)
	struct Pair(time, value)
	local IKObjects = #()
	local BoneArray = #()
	local ConstraintTargets = #()
	local ConstrainedBones = #()
	
	fn InvertArray A =
	(
		n = #()
		for i = A.count to 1 by -1 do
		(
			append n A[i]
		)
		return n
	)
	
	fn OptimizeArray A =
	(
		for i = 1 to A.count do 
		for j = A.count to i+1 by -1 do 
		 if A[i] == A[j] do 
		  deleteItem A j
	)
	fn GetNames o =
	(
		a = #()
		for b in o do append a b.name
		return a
	)
	fn UpdateList =
	(
		s = GetNames BoneArray
		mainroll.lbx1.items = s
	)
	fn VerifySceneNodes =
	(
		b = true
		for o = BoneArray.count to 1 by -1 do
		(
			if IsValidNode BoneArray[o] == false then b = false; deleteitem BoneArray o
		)
		if b= false then UpdateList()
	)
	fn GetTransformations obj keys =
	(
		a = #()
		for k in keys do
		(
			at time k.time append a (Pair k.time (copy obj.transform))
		)
		return a
	)
	fn CleanTransformations obj =
	(
			k = obj.pos.controller.keys
			for c = k.count to 1 by -1 do deletekey k c
			k = obj.scale.controller.keys
			for c = k.count to 1 by -1 do deletekey k c
	)
	fn GenerateInterpKeys start:0 end:100 interp:5 =
	(
		a = #()
		for k = start to end by interp do append a (Pair k undefined)
		return a
	)
	fn ResetControllers obj =
	(
		with animate on
		(
			at time 0f
			(
				m = obj.transform
				n = obj.rotation.controller.count
				for i = n to 1 by -1 do
				(
					if (obj.rotation.controller.GetName i ) == "Orientation Constraint" then
					(
						obj.rotation.controller.delete i
					)
					else if (obj.rotation.controller.GetName i ) == "LookAt Constraint" then
					(
						obj.rotation.controller.delete i
					)
				)
				obj.rotation.controller = TCB_Rotation()
				obj.transform = m
			)
		)
	)
	fn OptimizeKeys A =
	(
		for i = 1 to A.count do 
		for j = A.count to i+1 by -1 do 
		 if A[i].time == A[j].time do 
		  deleteItem A j
	)
	fn CompareKeys a b =
	(
		if a.time < b.time then return -1
		else if a.time > b.time then return 1
		else return 0
	)
	fn GatherEnables I =
	(
		a = copy I.controller.enabled.controller
		deleteKeys I.controller.enabled.controller #Allkeys
		I.controller.enabled = 1.0
		return a
	)
	fn GatherXtraKeys I =
	(
		a = #()
		b = I.transform.controller.startjoint
		while b != undefined do
		(
			join a b.pos.controller.keys
			join a b.rotation.controller.keys
			b = b.parent
		)
		return a
	)
	fn GatherXtraKeys2 I =
	(
		a = #()
		b = I
		while b != undefined do
		(
			join a b.pos.controller.keys
			join a b.rotation.controller.keys
			b = b.parent
		)
		return a
	)
	fn GatherKeys I =
	(
		local temp = #()
		local b = I
		while I != undefined do
		(
			join temp I.pos.controller.keys
			join temp I.rotation.controller.keys
			I = I.parent
		)
		I = b
		while I.children[1] != undefined do
		(
			join temp I.children[1].pos.controller.keys
			join temp I.children[1].rotation.controller.keys
			I = I.children[1]
		)
		I = b
		x = GatherXtraKeys b
		join temp x
		x = undefined
		if I.transform.controller.VHTarget != undefined then
		(
			x = GatherXtraKeys2 I.transform.controller.VHTarget
			join temp x
			x = undefined
		)
		qsort temp CompareKeys
		OptimizeKeys temp
		return temp
	)
	
	fn GatherKeys_Constraint I =
	(
		a = #()
		b = I
		while I != undefined do
		(
			join a I.pos.controller.keys
			join a I.rotation.controller.keys
			I = I.parent
		)
		I = b
		while I.children[1] != undefined do
		(
			join a I.children[1].pos.controller.keys
			join a I.children[1].rotation.controller.keys
			I = I.children[1]
		)
		qsort a CompareKeys
		OptimizeKeys a
		return a
	)
	
	fn IsBone o = (return classof o == BoneGeometry)
	fn IsAny o = (return true)
	
	fn CheckBones BList =
	(
		t = false
		i = 1
		a = BList.count
		b = BoneArray.count
		while i <= a and t == false do
		(
			j = 1
			while j <= b and t == false do
			(
				if BList[i] == BoneArray[j] then t = true
				j += 1
			)
			i += 1
		)
		return t
	)
	
	fn GatherBones startnode endnode =
	(
		a = #()
		n = startnode
		append a n
		(
			while n.children != undefined and n.children[1] != endnode do
			(
				n = n.children[1]
				append a n
			)
		)
		return a
	)
	
	fn GetIkObjects keys:false =
	(
		IKObjects = undefined --clean memory
		IKObjects = #()
		for o in Helpers do if classof o == IK_Chain_Object then
		(
			c = o.transform.controller
			b = (GatherBones c.startjoint c.endjoint)
			v = CheckBones b
			if v == true then
			(
				if keys == true then k = (GatherKeys o) else k = undefined
				g = GatherEnables o --for safety
				append IKObjects (IKObject o c b k g)
			)
		)
		if IKObjects.count <= 0 then IKObjects = undefined
	)
	fn ResetIK o =
	(
		for s in o do
		(
			s.obj.controller.enabled = 1.0
			for k in s.enables.keys do addNewKey s.obj.controller.enabled.controller k.time
		)
	)
	
	fn HasOrientationController =
	(
		try
		(
			n = o.rotation.controller.Orientation_Constraint
			return true
		)
		catch
		(
			return false
		)
	)
	
	fn HasLookAtController =
	(
		try
		(
			n = o.rotation.controller.LookAt_Constraint
			return true
		)
		catch
		(
			return false
		)
	)
	
	fn LoadConstrainedObjects = --only loads orientation and lookAt Constraints
	(
		for o in BoneArray do
		(
			if (classof o.rotation.controller) == rotation_list then
			(
				n = o.rotation.controller.count
				for i = 1 to n do
				(
					if (o.rotation.controller.GetName i ) == "Orientation Constraint" then
					(
						for s = 1 to o.rotation.controller.Orientation_Constraint.getNumTargets() do
						(
							append ConstraintTargets (o.rotation.controller.Orientation_Constraint.getNode s)
						)
						append ConstrainedBones o
					)
					else if (o.rotation.controller.GetName i ) == "LookAt Constraint" then
					(
						for s = 1 to o.rotation.controller.LookAt_Constraint.getNumTargets() do
						(
							append ConstraintTargets (o.rotation.controller.LookAt_Constraint.getNode s)
						)
						append ConstrainedBones o
					)
				)
			)
		)
	)
	
	fn SmartSnap mixedkeys:false clean:false clean2:false clean3:false optimize:false tresshold:0.5 constraints:false start:0 end:100 interp:5 forceinterp:false AutoDetect:false = --not so accurate, but snaps key points
	(
		--disableSceneRedraw() --looks like it produces wrong effects
		GetIkObjects keys:true
		if constraints == true then LoadConstrainedObjects()
		g = #()
		if IKObjects != undefined then
		(
			for o in IKObjects do join g o.keys
			qsort g CompareKeys
			OptimizeKeys g
			if AutoDetect == true then end = g[g.count].time
			with animate on
			(
				len = animationRange
				animationRange = interval 0 g[g.count].time
				for o in IKObjects do
				(
					select o.obj
					sliderTime = 0f
					IKChainControl.action.Snap()
				)
				for o in IKObjects do
				(
					select o.obj
					for k = 1 to g.count do
					(
						sliderTime = g[k].time
						IKChainControl.action.Snap()
					)
					k = 1
				)
				sliderTime = 0f
				animationRange = len
			)
			if constraints == true then
			(
				if mixedkeys == false then g = #()
				for o in ConstraintTargets do join g (GatherKeys_Constraint o)
				for o in ConstrainedBones do join g (GatherKeys_Constraint o)
				if g[g.count].time > end then end =  g[g.count].time
				if forceinterp == true then join g (GenerateInterpKeys start:start end:end interp:interp)
				qsort g CompareKeys
				OptimizeKeys g
				for o in ConstrainedBones do
				(
					Keys = GetTransformations o g
					ResetControllers o
					with animate on
					(
						for k in Keys do at time k.time
						(
							o.transform = k.value
						)
						CleanTransformations o
					)
				)
			)
			ResetIK IKObjects
			if clean == true then at time 0f
			(
				for o in IKObjects do
				(
					if clean3 == true then \
						if o.controller.VHTarget != undefined then delete o.controller.VHTarget
					delete o.obj
				)
				IKObjects = #()
			)
			if clean3 == true and constraints == true then
			(
				for o in ConstraintTargets do delete o
			)
			if optimize == true then
			(
				t = 0.5f
				for x = 1 to BoneArray.count do reduceKeys BoneArray[x].rotation.controller tresshold t (interval 0f g[g.count].time)
			)
			messageBox "Done!"
		)
		--enableSceneRedraw() --causes an unknown error
	)
	
	fn InterpolatedSnap clean:false clean2:false clean3:false start:0 end:100 interp:5 optimize:false tresshold:0.5 AutoDetect:false forceinterp:false constraints:false = --very accurate
	(
		--disableSceneRedraw()
		GetIkObjects keys:AutoDetect
		if constraints == true then LoadConstrainedObjects()
		if AutoDetect == true then g = #()
		if IKObjects != undefined then
		(
			if AutoDetect == true then
			(
				for o in IKObjects do join g o.keys
				qsort g CompareKeys
				OptimizeKeys g
				end = g[g.count].time
			)
			with animate on
			(
				len = animationRange
				animationRange = interval start end
				for o in IKObjects do
				(
					select o.obj
					sliderTime = 0f
					IKChainControl.action.Snap()
				)
				for o in IKObjects do
				(
					select o.obj
					for k = start to end by interp do
					(
						sliderTime = (k as time)
						IKChainControl.action.Snap()
					)
					k = 1
				)
				sliderTime = 0f
				animationRange = len
			)
			if constraints == true then
			(
				if g[g.count].time > end then end =  g[g.count].time
				g = (GenerateInterpKeys start:start end:end interp:interp)
				qsort g CompareKeys
				OptimizeKeys g
				for o in ConstrainedBones do
				(
					Keys = GetTransformations o g
					ResetControllers o
					with animate on
					(
						for k in Keys do at time k.time
						(
							o.transform = k.value
						)
						CleanTransformations o
					)
				)
			)
			ResetIK IKObjects
			if clean == true then at time 0f
			(
				for o in IKObjects do
				(
					if clean3 == true then \
						if o.controller.VHTarget != undefined then delete o.controller.VHTarget
					delete o.obj
				)
				IKObjects = #()
			)
			if clean3 == true and constraints == true then
			(
				for o in ConstraintTargets do delete o
			)
			if optimize == true then
			(
				t = (interp as time)
				q = (start as time)
				w = (end as time)
				for x = 1 to BoneArray.count do reduceKeys BoneArray[x].rotation.controller tresshold t (interval q w)
			)
			messageBox "Done!"
		)
		--enableSceneRedraw()
	)
	
	fn MixedSnap mixedkeys:false clean:false clean2:false clean3:false optimize:false tresshold:0.5 constraints:false start:0 end:100 interp:5 forceinterp:false AutoDetect:false = --not so accurate, but snaps key points
	(
		--disableSceneRedraw() --looks like it produces wrong effects
		GetIkObjects keys:true
		if constraints == true then LoadConstrainedObjects()
		g = #()
		if IKObjects != undefined then
		(
			for o in IKObjects do join g o.keys
			if AutoDetect == true then end = g[g.count].time
			join g (GenerateInterpKeys start:start end:end interp:interp)
			qsort g CompareKeys
			OptimizeKeys g
			if AutoDetect == true then end = g[g.count].time
			with animate on
			(
				len = animationRange
				animationRange = interval 0 g[g.count].time
				for o in IKObjects do
				(
					select o.obj
					sliderTime = 0f
					IKChainControl.action.Snap()
				)
				for o in IKObjects do
				(
					select o.obj
					for k = 1 to g.count do
					(
						sliderTime = g[k].time
						IKChainControl.action.Snap()
					)
					k = 1
				)
				sliderTime = 0f
				animationRange = len
			)
			if constraints == true then
			(
				if mixedkeys == false then g = #()
				for o in ConstraintTargets do join g (GatherKeys_Constraint o)
				for o in ConstrainedBones do join g (GatherKeys_Constraint o)
				if AutoDetect == true then end = g[g.count].time
				join g (GenerateInterpKeys start:start end:end interp:interp)
				qsort g CompareKeys
				OptimizeKeys g
				for o in ConstrainedBones do
				(
					Keys = GetTransformations o g
					ResetControllers o
					with animate on
					(
						for k in Keys do at time k.time
						(
							o.transform = k.value
						)
						CleanTransformations o
					)
				)
			)
			ResetIK IKObjects
			if clean == true then at time 0f
			(
				for o in IKObjects do
				(
					if clean3 == true then \
						if o.controller.VHTarget != undefined then delete o.controller.VHTarget
					delete o.obj
				)
				IKObjects = #()
			)
			if clean3 == true and constraints == true then
			(
				for o in ConstraintTargets do delete o
			)
			if optimize == true then
			(
				t = 0.5f
				for x = 1 to BoneArray.count do reduceKeys BoneArray[x].rotation.controller tresshold t (interval 0f g[g.count].time)
			)
			messageBox "Done!"
		)
		--enableSceneRedraw() --causes an unknown error
	)

	
	rollout aboutroll "About" width:234 height:124
	(
		GroupBox grp1 "About" pos:[5,12] width:221 height:103
		label lbl1 "NeoDexIKSnapper has been created by BlinkBoy for the powerful set of NeoDex Tools" pos:[17,32] width:198 height:39
		label lbl2 "This version had been finished on: 05/02/2009" pos:[19,79] width:202 height:29
	)
	
	rollout mainroll "Snapper" width:226 height:751
	(
		listbox lbx1 "BoneChains" pos:[38,421] width:144 height:9
		button btn1 "Search and Snap!" pos:[59,689] width:102 height:22
		button btn2 "Add" pos:[40,564] width:52 height:19 
		pickbutton btn3 "Pick" pos:[91,564] width:43 height:19 filter:IsBone
		button btn4 "Delete" pos:[132,564] width:52 height:19
		checkbox chk1 "Erase Ik Chains after finishing." pos:[31,640] width:161 height:16
		GroupBox grp1 "IK to FK Snapper" pos:[17,3] width:194 height:744
		GroupBox grp3 "Objects" pos:[24,407] width:175 height:200
		GroupBox grp4 "Snapping" pos:[25,610] width:175 height:105
		GroupBox grp5 "Settings" pos:[24,22] width:175 height:191
		radiobuttons rdo1 "" pos:[61,51] width:107 height:48 labels:#("Smart Snap", "Interpolated Snap", "Mixed Snap") default:1 columns:1
		GroupBox grp6 "Snapping Method" pos:[36,34] width:153 height:72
		GroupBox grp7 "Interpolated Snap" pos:[34,110] width:151 height:99
		spinner spn1 "Start:   " pos:[55,126] width:93 height:16 range:[0,999999,0] type:#integer scale:1
		spinner spn2 "End:    " pos:[55,145] width:93 height:16 range:[0,999999,100] type:#integer scale:1
		spinner spn3 "Interp: " pos:[55,184] width:93 height:16 range:[1,100,5] type:#integer scale:1
		GroupBox grp8 "Optimization" pos:[25,215] width:175 height:66
		checkbox chk3 "Optimize Keys" pos:[56,236] width:94 height:18
		spinner spn4 "Threshold" pos:[50,255] width:100 height:16 range:[0,100,0.5] scale:0.05
		button btn23 "About" pos:[47,718] width:129 height:25
		GroupBox grp15 "Constraints" pos:[24,289] width:175 height:115
		checkbox chk7 "Snap Constrained Bones." pos:[42,305] width:143 height:19 checked:true
		label lbl2 "Note: snapping constrained Bones causes the uncontraining of the former." pos:[40,354] width:144 height:45
		checkbox chk14 "Force Interpolation" pos:[41,329] width:108 height:17 checked:false
		button btn21 "?" pos:[156,325] width:23 height:18
		checkbox chk24 "AutoDetect" pos:[47,165] width:107 height:13
		checkbox chk6 "Mixe Constraints and IK Keys" pos:[32,625] width:155 height:16 checked:true
		button btn7 "?" pos:[40,66] width:18 height:16
		checkbox chk19 "Erase Contraints after finishing" pos:[31,657] width:161 height:15
		checkbox chk28 "Erase IKTargets after finishing" pos:[31,673] width:161 height:15
		checkbox chk9 "Only Bones" pos:[44,586] width:136 height:16 checked:true
		on btn2 pressed do
		(
			if chk9.checked == true then o = selectbyname filter:IsBone else o = selectbyname filter:IsAny
			if o != undefined then
			(
				join BoneArray o
				OptimizeArray BoneArray
				lbx1.items = (GetNames BoneArray)
			)
		)
		on btn3 picked obj do
		( 
			if obj != undefined do
			(
				append BoneArray obj
				OptimizeArray BoneArray
				lbx1.items = (GetNames BoneArray)
			)
		)
		on btn4 pressed do
		(
			a = lbx1.selection
			if a != 0 then
			(
				deleteitem BoneArray a
				lbx1.items = (GetNames BoneArray)
			)
		)
		on btn1 pressed do
		(
			--VerifySceneNodes()
			if rdo1.state == 1 then SmartSnap mixedkeys:chk6.checked clean:chk1.checked clean2:chk19.checked clean3:chk28.checked optimize:chk3.checked tresshold:spn4.value \
				constraints:chk7.checked start:spn1.value end:spn2.value interp:spn3.value forceinterp:chk14.checked AutoDetect:chk24.checked else
			(
				if spn1.value < spn2.value then
				(
					if rdo1.state == 2 then InterpolatedSnap clean:chk1.checked clean2:chk19.checked clean3:chk28.checked start:spn1.value end:spn2.value interp:spn3.value \
							optimize:chk3.checked tresshold:spn4.value AutoDetect:chk24.checked forceinterp:chk14.checked constraints:chk7.checked else \
						MixedSnap mixedkeys:chk6.checked clean:chk1.checked clean2:chk19.checked clean3:chk28.checked optimize:chk3.checked tresshold:spn4.value \
							constraints:chk7.checked start:spn1.value end:spn2.value interp:spn3.value forceinterp:chk14.checked AutoDetect:chk24.checked
				)
				else messagebox "Start frame can't be higher than the end!" beep:true
			)
		)
		on btn23 pressed do
		(
			createDialog aboutroll
		)
		on btn21 pressed do messagebox ("\tForce Interpolation is a method applied to constrained bones while using Smart Snap.\n\n" + \
			"\tIt produces keys through Interpolated Snapping. Use it if you have constrained bones whose targets are not/partially animated; use the Interpolation settings for this method.")
		on chk24 changed v do if v == true then spn2.enabled = false else spn2.enabled = true
		on btn7 pressed do messagebox ("\tSmart Snap is a method in which the snapper looks for keys of objects which could affect the Bone chain or the IK Solvers, and snaps at those times.\n\n" + \
			"\tInterpolated Snap is a method in which keys snapping is done every set of time from an initial frame (start frame) to an end frame, the number of cycles is setted by Interp value. An Interp value of 3 is suggested for an fps of 30.\n\n" + \
			"\tMixed Snap is a method which combines both Smart and Interpolated Snap. Use it for accurate results at mid costs, suggested interp for this method: 5.")
	)
	
	Main = newrolloutfloater ("NeoDeX IK snapper " + IKSnapperVersion) 240 783
	addrollout mainroll Main
)
