
macroscript NeoDex_Importer
	buttonText:"Import Wc3 Model"
	category:"NeoDex Toolkit"
	internalCategory:"Import/Export" 
(
	struct ImporterSettings (
		importMaterials = true,
		importSkinning = true,
		importAnimations = true,
		importObjects = true,
		importBones = true,
		importHelpers = true,
		importLights = true,
		importAttachments = true,
		importPE1 = true,
		importPE2 = true,
		importRE = true,
		importEO = true,
		importCS = true,
		importCameras = true,
		importTransAnim = true,
		importRotAnim = true,
		importScaleAnim = true,
		importTXAnim = true,
		importUVAnim = true,
		importVisAnim = true,
		importColorAnim = true,
		importParamAnim = true,
		importHelpersAsMaxBones = true,
		importBonesAsMaxBones = true,
		optimizeGeometry = true,
		optimizeBonesHelpers = true,
		importFormat = #NeoDex
	)
    local neoDexIPVersion = "1.0"
	local Settings = ImporterSettings ()
	-- Includes
	include "NeoDexModules\\Graph.ms"
	include "NeoDexModules\\Octree.ms"
	include "NeoDexModules\\ProgressUtility.ms"
	include "NeoDexModules\\Wc3Model.ms"
	include "NeoDexModules\\Wc3Animation.ms"
	include "NeoDexModules\\UtilityFunctions.ms"
	include "NeoDexModules\\NeoDexIO.ms"
	include "NeoDexModules\\ErrorReporter.ms"
	include "NeoDexModules\\NeoDexMDXReader.ms"
	include "NeoDexModules\\NeoDexModelRelinker.ms"
	include "NeoDexModules\\NeoDexOptimize.ms"
	include "NeoDexModules\\NeoDexSceneRebuilder.ms"
	-- end Includes
	global ImportedModel
	local Mode
	local modelpath
	local notGmax = not gmax
	local OnControlSet = true
	rollout importerRoll "NeoDex Importer" width:410 height:493
	(
		button btn2 "Import" pos:[149,461] width:58 height:22
		GroupBox grp3 "Geometry" pos:[14,9] width:104 height:51
		checkbox chk1 "Skinned" pos:[30,29] width:70 height:16 enabled:false checked:true
		GroupBox grp4 "Objects" pos:[11,134] width:236 height:179
		GroupBox grp5 "Materials" pos:[13,68] width:114 height:63
		checkbox chk2 "Import Textures" pos:[19,109] width:94 height:17 enabled:false checked:true
		checkbox chk3 "Import Objects" pos:[22,150] width:125 height:18 enabled:false checked:true
		checkbox chk4 "Bones" pos:[29,185] width:94 height:17 enabled:false checked:true
		checkbox chk5 "Helpers" pos:[29,206] width:77 height:18 enabled:false checked:true
		checkbox chk6 "Lights" pos:[29,228] width:60 height:17 enabled:false checked:true
		checkbox chk7 "Attachments" pos:[29,251] width:82 height:17 enabled:false checked:true
		checkbox chk8 "Particle Emitters 1" pos:[127,185] width:107 height:15 enabled:false checked:notGmax
		checkbox chk9 "Particle Emitters 2" pos:[127,206] width:105 height:17 enabled:false checked:true
		checkbox chk10 "Event Objects" pos:[29,273] width:87 height:16 enabled:false checked:true
		checkbox chk11 "Ribbon Emitters" pos:[127,228] width:105 height:15 enabled:false checked:true
		checkbox chk12 "Collision Shapes" pos:[127,251] width:99 height:16 enabled:false checked:true
		GroupBox grp7 "Animations" pos:[136,10] width:257 height:124
		checkbox chk13 "Import Animations" pos:[144,26] width:108 height:19 enabled:false checked:true
		checkbox chk14 "Rotations" pos:[159,54] width:74 height:15 enabled:false checked:true
		checkbox chk15 "Translation" pos:[159,73] width:80 height:16 enabled:false checked:true
		checkbox chk16 "Scale" pos:[159,93] width:79 height:15 enabled:false checked:true
		checkbox chk17 "Parameter" pos:[249,54] width:89 height:17 enabled:false checked:true
		checkbox chk18 "Unwrap Animations" pos:[249,73] width:114 height:17 enabled:false checked:true
		checkbox chk19 "Texture Animations" pos:[249,93] width:113 height:14 enabled:false checked:notGmax
		checkbox chk20 "Visibility" pos:[159,111] width:62 height:15 enabled:false checked:true
		checkbox chk21 "Import Materials" pos:[19,87] width:93 height:17 enabled:false checked:true
		GroupBox grp9 "Settings" pos:[251,134] width:145 height:180
		radiobuttons rdo2 "Fast Settings" pos:[262,149] width:128 height:110 enabled:true labels:#("Custom", "Static No Materials", "Static Materials", "Animated No Skinning", "Animated No objects", "All") default:6 columns:1
		radiobuttons rdo3 "Mode:" pos:[264,264] width:79 height:46 enabled:false labels:#("New Scene", "Merge") columns:1
		checkbox chk22 "Color" pos:[248,111] width:127 height:15 enabled:false checked:true
		checkbox chk23 "Cameras" pos:[127,273] width:96 height:13 enabled:false checked:true
		GroupBox grp6 "Progress" pos:[10,392] width:382 height:61
		progressBar pb1 "ProgressBar" pos:[32,433] width:355 height:11 color:(color 30 10 190)
		label lbl1 "Idle..." pos:[35,409] width:158 height:17
		groupBox grp14 "Optimizer" pos:[10,320] width:381 height:68
		checkbox chk51 "Optimize Geometry" pos:[25,340] width:274 height:16 checked:true
		checkbox chk52 "Optimize Bones and Helpers" pos:[26,362] width:256 height:14 checked:true
		fn setSettings =
		(
			Settings.importMaterials = chk21.checked
			Settings.importSkinning = chk1.checked
			Settings.importAnimations = chk13.checked
			Settings.importObjects = chk3.checked
			Settings.importBones = chk4.checked
			Settings.importHelpers = chk5.checked
			Settings.importLights = chk6.checked
			Settings.importAttachments = chk7.checked
			Settings.importPE1 = chk8.checked
			Settings.importPE2 = chk9.checked
			Settings.importRE = chk11.checked
			Settings.importEO = chk10.checked
			Settings.importCS = chk12.checked
			Settings.importCameras = chk23.checked
			Settings.importTransAnim = chk14.checked
			Settings.importRotAnim = chk15.checked
			Settings.importScaleAnim = chk16.checked
			Settings.importTXAnim = chk19.checked
			Settings.importUVAnim = chk18.checked
			Settings.importVisAnim = chk20.checked
			Settings.importColorAnim = chk22.checked
			Settings.importParamAnim = chk17.checked
			Settings.optimizeGeometry = chk51.checked
			Settings.optimizeBonesHelpers = chk52.checked
		)
		fn checkObjects b =
		(
			chk3.checked = b
			chk4.checked = b
			chk5.checked = b
			chk6.checked = b
			chk7.checked = b
			chk8.checked = b and (not gmax)
			chk9.checked = b
			chk11.checked = b
			chk10.checked = b
			chk12.checked = b
			chk23.checked = b
		)
		fn checkBH b =
		(
			chk3.checked = b
			chk4.checked = b
			chk5.checked = b
		)
		fn checkSkinning b =
		(
			chk1.checked = b
		)
		fn checkMaterials b =
		(
			chk21.checked = b
			chk2.checked = b
		)
		fn checkAnimations b =
		(
			chk13.checked = b
			chk14.checked = b
			chk15.checked = b
			chk16.checked = b
			chk17.checked = b
			chk18.checked = b
			chk19.checked = b and (not gmax)
			chk20.checked = b
			chk22.checked = b
		)
		fn enableAnimations b =
		(
			chk13.enabled = b
			chk14.enabled = b
			chk15.enabled = b
			chk16.enabled = b
			chk17.enabled = b
			chk18.enabled = b
			chk19.enabled = b and (not gmax)
			chk20.enabled = b
			chk22.enabled = b
		)
		fn enableObjects b =
		(
			chk3.enabled = b
			chk4.enabled = b
			chk5.enabled = b
			chk6.enabled = b
			chk7.enabled = b
			chk8.enabled = b and (not gmax)
			chk9.enabled = b
			chk11.enabled = b
			chk10.enabled = b
			chk12.enabled = b
			chk23.enabled = b
		)
		on btn2 pressed do
		(
			local noError = true
			local model = ImportedModel
			progressInitiate lbl1 pb1
			setSettings ()
			if Mode then
				try (
					progressDownLevel 50 1
					with redraw off (relinkModel model)
					progressUpdateItem "Cleaning up..."
					gc ()
					progressUpLevel ()
					progressUpdateItem "Optimizing Model..."
					optimizeImportModel model
					progressDownLevel 50 1
					rebuildSceneModel model modelpath
					progressUpLevel ()
					progressFinalize ()
				)
				catch (
					messageBox "Export Failed: Error while rebuilding scene\n Please open the listener and report the bug"
					if (not gmax) then format "*** % ***\n" (getCurrentException()) to:listener
					noError = false
				)
			else
			(
				MXSDebugger.showFirstFrameOnly = true
				progressDownLevel 50 1
				with redraw off (relinkModel model)
				gc ()
				progressUpLevel ()
				progressUpdateItem "Optimizing Model..."
				optimizeImportModel model
				progressDownLevel 50 1
				rebuildSceneModel model modelpath
				progressUpLevel ()
				progressFinalize ()
			)
			lbl1.caption = "Idle..."
			btn2.enabled = false
			messageBox "Done!"
			destroyDialog importerRoll
		)
		on chk1 changed newState do
		(
			if OnControlSet then (
				OnControlSet = false
				if newState then
					checkBH true
				OnControlSet = true
			)
		)
		on chk3 changed newState do
		(
			if OnControlSet then (
				OnControlSet = false
				checkObjects newState
				enableObjects newState
				chk3.enabled = true
				OnControlSet = true
			)
		)
		on chk4 changed newState do
		(
			if OnControlSet then (
				OnControlSet = false
				if (not newState) then
					chk1.checked = false
				OnControlSet = true
			)
		)
		on chk13 changed newState do
		(
			if OnControlSet then (
				OnControlSet = false
				checkAnimations newState
				enableAnimations newState
				chk13.enabled = true
				OnControlSet = true
			)
		)
		on rdo2 changed newState do
		(
			OnControlSet = false
			for c in importerRoll.controls where classof c == CheckBoxControl do
				c.enabled = false
			case newState of
			(
				1:
				(
					for c in importerRoll.controls where classof c == CheckBoxControl do
						c.enabled = true
					chk19.enabled = (not gmax)
					chk8.enabled = (not gmax)
				)
				2:
				(
					checkMaterials false
					checkSkinning false
					checkAnimations false
					checkObjects false
				)
				3:
				(
					checkMaterials true
					checkSkinning false
					checkAnimations false
					checkObjects false
				)
				4:
				(
					checkMaterials true
					checkSkinning false
					checkAnimations true
					checkObjects false
					checkBH true
				)
				5:
				(
					checkMaterials true
					checkSkinning true
					checkAnimations true
					checkObjects false
					checkBH true
				)
				6:
				(
					checkMaterials true
					checkSkinning true
					checkAnimations true
					checkObjects true
				)
			)
			if (not chk13.checked) then
			(
				enableAnimations false
				chk13.enabled = newState == 1
			)
			if (not chk3.checked) then
			(
				enableObjects false
				chk3.enabled = newState == 1
			)
			OnControlSet = true
		)
	)
	
	rollout loadRoll "NeoDex Importer" width:211 height:136
	(
		groupBox grp2 "Mode" pos:[7,14] width:191 height:68
		button btn3 "Open Model" pos:[65,93] width:76 height:26
		radioButtons rdo1 "" pos:[21,36] width:96 height:32 labels:#("Standard Mode", "Debug Mode")
		on btn3 pressed do
		(
			local noError = true
			infile_name = getOpenFileName types:"MDX File (*.mdx)|*.mdx"
			if infile_name == undefined then
				return OK
			modelpath = getFilenamePath infile_name
			Mode = rdo1.state == 1
			if Mode then
			(
				try
					ImportedModel = InputMDX infile_name
				catch
				(
					messageBox "Export Failed: Error while reading the mdx file\n Please open the listener and report the bug"
					if (not gmax) then format "*** % ***\n" (getCurrentException()) to:listener
					noError = false
				)
			)
			else
			(
				ImportedModel = InputMDX infile_name
			)
			destroyDialog loadRoll
			if noError then
				createDialog importerRoll
		)
	)

	createDialog loadRoll
)
