
macroscript NeoDex_Key_Reducer
    buttonText:"Key Reducer"
    category:"NeoDex Toolkit"
	internalCategory:"Tools" 
(
    local krversion = "1.0"
	struct Animation(name, starttime, endtime)
	local ObjectArray = #()
	local RPAnims = #()
	local THAnims = #()
	local AnimList
	fn OptimizeArray A =
	(
		for i = 1 to A.count do 
		for j = A.count to i+1 by -1 do 
		 if A[i] == A[j] do 
		  deleteItem A j
	)
	fn GetNames o =
	(
		a = #()
		for b in o do if b.name != undefined then append a b.name else append a "Unknown"
		return a
	)
	fn CleanKeys obj start end r p s=
	(
		if p == true then
		(
			k = obj.pos.controller.keys
			for c = k.count to 1 by -1 do
			(
				if k[c].time >= start and k[c].time <= end then deletekey k c
			)
		)
		if r == true then
		(
			k = obj.rotation.controller.keys
			for c = k.count to 1 by -1 do
			(
				if k[c].time >= start and k[c].time <= end then deletekey k c
			)
		)
		if s == true then
		(
			k = obj.scale.controller.keys
			for c = k.count to 1 by -1 do
			(
				if k[c].time >= start and k[c].time <= end then deletekey k c
			)
		)
	)
	fn GetHighestEnd p r s =
	(
		c = 0f
		For o in ObjectArray do
		(
			if p then  \
				if o.pos.IsAnimated then
				(
					n = o.pos.controller.keys[o.pos.controller.keys.count].time
					if n > c then c = n
				)
			if r then \
				if o.pos.IsAnimated then
				(
					n = o.pos.controller.keys[o.pos.controller.keys.count].time
					if n > c then c = n
				)
			if s then \
				if o.scale.IsAnimated then
				(
					n = o.scale.controller.keys[o.scale.controller.keys.count].time
					if n > c then c = n
				)
		)
		return c
	)

	fn ProduceAnim a b = --this function reads the animation data of each pair and produces an Anim object
	(
		x = filterString a.value "\n"
		local j = undefined
		for c in x do
		(
			if c[1] == "\"" and j == undefined then 
			(
				if c[c.count] != "\"" then j = substring c 2 (c.count-3) else j = substring c 2 (c.count-2)
			)
		)
		return (Animation j a.time b.time)
	)
	fn LoadAnims =
	(
		local s = "\*"
		local v = undefined
		if HasNoteTracks Rootnode then
		(
			Nt = GetNoteTrack Rootnode 1
			if Nt != undefined then
			(
				for k in Nt.keys do
				(
					if s == k.value and k.value != "\*" and v != undefined then
					(
						a = ProduceAnim v k
						if a != undefined then
						(
							append RPAnims (ProduceAnim v k)
							append THAnims 0.5
						)
						s = "\*"
						v = undefined
					)
					else
					(
						s = k.value
						v = k
					)
				)
			)
		)
	)
	fn GetAntiAnims End =
	(
		a = #()
		if RPAnims.count >= 1 then
		(
			if RPAnims[1].starttime > 1f then append a (interval 1f (RPAnims[1].starttime-1))
			for i = 1 to RPAnims.count do
			(
				if RPAnims[i+1] != undefined then \
					append a (interval (RPAnims[i].endtime + 1) (RPAnims[i+1].starttime - 1)) else
				(
					if End > RPAnims[i].endtime then append a (interval (RPAnims[i].endtime + 1) End)
				)
			)
		)
		return a
	)
	fn ReduceObjectKeys reduction:1 thresholdtype:1 threshold:0.5 position:true rot:true scaling:true external:false =
	(
		End = GetHighestEnd position rot scaling
		if reduction == 2 then
		(
			i = interval 0f End
			for o in ObjectArray do
			(
				if position == true then ReduceKeys o.pos.controller threshold 1f i
				if rot == true then ReduceKeys o.rotation.controller threshold 1f i
				if scaling == true then ReduceKeys o.scale.controller threshold 1f i
			)
		)
		else
		(
			if thresholdtype == 1 then
			(
				for s = 1 to RPAnims.count do
				(
					i = interval (RPAnims[s].starttime + 1) (RPAnims[s].endtime - 1)
					for o in ObjectArray do
					(
						if position == true then ReduceKeys o.pos.controller threshold 1f i
						if rot == true then ReduceKeys o.rotation.controller threshold 1f i
						if scaling == true then ReduceKeys o.scale.controller threshold 1f i
					)
				)
			)
			else
			(
				for s = 1 to RPAnims.count do
				(
					i = (interval (RPAnims[s].starttime + 1) (RPAnims[s].endtime - 1))
					t = THAnims[s]
					for o in ObjectArray do
					(
						if position == true then ReduceKeys o.pos.controller t 1f i
						if rot == true then ReduceKeys o.rotation.controller t 1f i
						if scaling == true then ReduceKeys o.scale.controller t 1f i
					)
				)
			)
		)
		if external == true then
		(
			w = GetAntiAnims End
			for q in w do
			(
				for o in ObjectArray do
				(
					CleanKeys o q.start q.end rot position scaling
				)
			)
		)
		messagebox "Done!" beep:true
	)
	rollout aboutroll "About" width:234 height:127
	(
		GroupBox grp1 "About" pos:[5,12] width:221 height:105
		label lbl1 "NeoDex Key Reducer has been created by BlinkBoy for the powerful set of NeoDex Tools." pos:[17,33] width:198 height:44
		label lbl2 "This version had been finished on: 05/03/2009" pos:[17,78] width:202 height:29
	)
	rollout mainroll "Settings" width:242 height:707
	(
		GroupBox grp1 "Objects" pos:[24,8] width:191 height:160
		listbox lbx1 "Objects:" pos:[44,22] width:142 height:7
		button btn1 "Add" pos:[43,141] width:71 height:20
		button btn2 "Remove" pos:[112,141] width:71 height:20
		GroupBox grp2 "Settings" pos:[24,173] width:191 height:477
		radiobuttons rdo1 "Reduction" pos:[50,188] width:136 height:46 labels:#("According to animations", "Global")
		GroupBox grp3 "Reduce:" pos:[48,239] width:140 height:81
		checkbox chk2 "Position" pos:[62,254] width:108 height:20 checked:true
		checkbox chk3 "Rotation" pos:[62,273] width:108 height:20 checked:true
		checkbox chk4 "Scale" pos:[62,295] width:108 height:20
		radiobuttons rdo2 "Threshold" pos:[45,324] width:110 height:46 labels:#("Global", "Animation Specific")
		GroupBox grp5 "Global Threshold" pos:[35,377] width:159 height:48
		spinner spn2 "Threshold: " pos:[69,397] width:90 height:16 range:[0,100,0.5] scale:0.05
		GroupBox grp6 "Animation Threshold" pos:[34,428] width:160 height:176 enabled:false
		listbox lbx2 "Animations" pos:[55,445] width:109 height:7 enabled:false
		spinner spn3 "Value: " pos:[61,570] width:89 height:16 enabled:false
		button btn3 "Do the Job!" pos:[55,655] width:128 height:24
		checkbox chk5 "Remove keys external to animations" pos:[34,612] width:147 height:28
		button btn31 "About" pos:[55,679] width:128 height:24
		on btn1 pressed do
		(
			o = selectbyname()
			if o != undefined then
			(
				join ObjectArray o
				OptimizeArray ObjectArray
				lbx1.items = (GetNames ObjectArray)
			)
		)
		on btn2 pressed do
		(
			a = lbx1.selection
			if a != 0 then
			(
				deleteitem ObjectArray a
				lbx1.items = (GetNames ObjectArray)
			)
		)
		on rdo1 changed i do
		(
			if i == 2 then
			(
				rdo2.state = 1
				grp6.enabled = false
				lbx2.enabled = false
				spn3.enabled = false
				grp5.enabled = true
				spn2.enabled = true
				rdo2.enabled = false
				chk5.enabled = false
				chk5.checked = false
			)
			else
			(
				rdo2.enabled = true
				chk5.enabled = true
			)
		)
		on rdo2 changed i do
		(
			if i == 1 then
			(
				grp6.enabled = false
				lbx2.enabled = false
				spn3.enabled = false
				grp5.enabled = true
				spn2.enabled = true
			)
			else
			(
				if lbx2.selection > 0 then spn3.value = THAnims[lbx2.selection]
				grp6.enabled = true
				lbx2.enabled = true
				spn3.enabled = true
				grp5.enabled = false
				spn2.enabled = false
			)
		)
		on lbx2 selected i do spn3.value = THAnims[i]
		on spn3 changed v do if lbx2.selection > 0 then THAnims[lbx2.selection] = v
		on btn3 pressed do
		(
			if ObjectArray.count > 0 then
			(
				if rdo1.state == 1 and RPAnims.count > 0 then
				(
					ReduceObjectKeys reduction:1 thresholdtype:rdo2.state threshold:spn2.value position:chk2.checked rot:chk3.checked scaling:chk4.checked external:chk5.checked
				)
				else
				(
					if rdo1.state != 2 then messagebox "No Animations, atleast 1 is required for these settings" else \
					ReduceObjectKeys reduction:2 thresholdtype:rdo2.state threshold:spn2.value position:chk2.checked rot:chk3.checked scaling:chk4.checked external:chk5.checked
				)
			)
			else messagebox "No objects selected" beep:true
		)
		on btn31 pressed do
		(
			createDialog aboutroll
		)
	)
	Main = newrolloutfloater ("NeoDex Key Reducer " + krversion) 235 740
	addrollout mainroll Main
	LoadAnims()
	AnimList = mainroll.controls[15]
	AnimList.items = GetNames RPAnims
)