
macroscript NeoDex_Mesh_Tools
	buttonText:"Mesh Tools"
	category:"NeoDex Toolkit" 
	internalCategory:"Tools" 
(
	local neoDexMTVersion = ".15"
	
	fn getAvarageFaceNormal obj faces =
	(
		local norm = [0,0,0]
		for f in faces do
			norm += getFaceNormal obj f
		norm = normalize norm
		norm
	)

	fn getSimilarVertices obj vertex thresshold =
	(
		b = #{}
		local numVerts = GetNumVerts obj
		b.count = numVerts
		for i = 1 to NumVerts do
		(
			local v = (getVert obj i) - vertex
			if (length v) < thresshold then
				b[i] = true
		)
		b
	)

	mapped fn recalculateNormals s =
	(
		if classof s == editable_mesh then
		(
			local numVerts = GetNumVerts s
			local func = meshop.getFacesUsingVert
			for i = 1 to numVerts do
			(
				local vertices = getSimilarVertices s (getVert s i) 0.2
				local faces =func s #{i}
				local norm = getAvarageFaceNormal s faces
				setNormal s i norm
			)
		)
	)
	
	rollout mainRoll "Mesh Tools" width:184 height:112
	(
		GroupBox grp1 "Normals Recalculator" pos:[15,13] width:148 height:76
		button btn1 "Recalculate on selected" pos:[30,45] width:117 height:26
		on btn1 pressed do
		(
			recalculateNormals selection
			messageBox "Done!"
		)
	)
	
	createdialog mainRoll
)
