
macroscript NeoDex_Object_Settings
    buttonText:"Object Settings" 
    category:"NeoDex Toolkit"
	internalCategory:"Tools" 
(
    local neoDexSTVersion = "1.3"
	fn B2I b = --takes a boolean and returns an integer
	(
		if b then 1 else 0
	)
	rollout settingsRoll "Settings" width:182 height:524
	(
		GroupBox grp1 "Mesh" pos:[14,158] width:158 height:118
		GroupBox grp2 "Options" pos:[15,11] width:157 height:138
		radiobuttons skinRdo "Skinning Method:" pos:[28,180] width:106 height:46 labels:#("Normal Skinning", "ArtTools Skinning") default:0
		radiobuttons billboardingRdo "Billboarding" pos:[36,29] width:94 height:94 labels:#("None", "Full", "Pivot on X Axis", "Pivot on Y Axis", "Pivot on Z Axis") default:0
		button aboutSkin "?" pos:[30,229] width:24 height:17
		checkbox cameraChk "Camera Anchored" pos:[33,128] width:118 height:20 enabled:true checked:false
		GroupBox grp6 "Super Spray Extra" pos:[9,445] width:160 height:73
		edittext part1Edit "" pos:[23,487] width:142 height:17
		label lbl1 "Model Path:" pos:[22,461] width:63 height:15
		checkbox selectChk "Unselectable" pos:[28,252] width:110 height:17
		checkbox chk3 "Bake Animations" pos:[19,307] width:111 height:16
		spinner spn1 "Bake Interp" pos:[32,330] width:98 height:16 range:[1,100,5] type:#integer scale:1
		GroupBox grp4 "Animations" pos:[10,286] width:156 height:148
		GroupBox grp5 "On which transformations" pos:[20,353] width:138 height:77
		checkbox chk4 "Position" pos:[30,368] width:76 height:17 enabled:false
		checkbox chk5 "Rotation" pos:[30,388] width:77 height:19 enabled:false
		checkbox chk6 "Scale" pos:[30,410] width:80 height:14 enabled:false
		button aboutBake "?" pos:[133,301] width:20 height:20
		on skinRdo changed newState do
			for s in selection do setUserProp s "Wc3Skin" newState
		on billboardingRdo changed newState do
			for s in selection do setUserProp s "Billboard" newState
		on aboutSkin pressed do
		(
			messageBox (
				"NeoDex 2 supports two skinning methods: Skin modifiers and Art Tools Skinning\n\n" +
				"Normal Skinning just uses any skin modifier found or the bone linked\n" +
				"Art tools Skinning, unifies vertices of detached meshes at exporting\n" +
				"Only use Art Tools Skinning on meshes which you want to blend\n" +
				"\n This option is disbled if you have non meshes within selection"
			)
		)
		on cameraChk changed newState do
			for s in selection do setUserProp s "CameraAnchored" (B2I newState)
		on part1Edit changed newState do
			for s in selection do setUserProp s "ParticlePath" newState
		on selectChk changed newState do
			for s in selection do setUserProp s "Unselectable" (B2I newState)
		on aboutBake pressed do
		(
			messageBox (
				"Bake animations is an advanced feuture for animators. " +
				"What it does is simply try to approximate animations of an object with unsupported controlers. " +
				"This is useful if you have link-constraints on an object or you use advanced tools." +
				"such as wired parameters, unsupported IK solvers (limb and HI are supported, so don't use this for them), " +
				"CAT Animation systems, etc.\n\n I suggest to use it with caution and only when needed since it generates a lot of keys."
			)
		)
	)
	Main = newrolloutfloater ("NeoDex Object Settings " + neoDexSTVersion) 200 400
	addrollout settingsRoll Main
	NeoDexSTSettingsRoll = settingsRoll
	
	NeoDexSTLoadFNSettings ()
	callbacks.removeScripts #selectionSetChanged
	callbacks.addscript #selectionSetChanged "NeoDexSTLoadFNSettings  ()"
)
