
macroscript NeoDex_Renderer
    buttonText:"Wc3 Renderer"
    category:"NeoDex Toolkit"
	internalCategory:"Tools" 
(
    local neoDexRDVersion = ".40"
	local gmax = (cylgizmo == undefined)
	fn Wc3Render =
	(
		callbacks.removeScripts #preRender id:#NeoDexRender
		callbacks.removeScripts #postRender id:#NeoDexRender
		callbacks.addScript #preRender "preRenderWc3 ()" id:#NeoDexRender
		callbacks.addScript #postRender "postRenderWc3 ()" id:#NeoDexRender
		render ()
		callbacks.removeScripts #preRender id:#NeoDexRender
		callbacks.removeScripts #postRender id:#NeoDexRender
	)
	
	rollout optionsRoll "Render Settings" width:347 height:384
	(
		GroupBox grp1 "Elements to render" pos:[5,98] width:135 height:83
		checkbox chk1 "Ribbon Emitters" pos:[17,122] width:111 height:20 checked:true
		checkbox chk2 "Particle Emitters 2" pos:[17,149] width:110 height:17 enabled:false
		button btn1 "Render" pos:[107,344] width:95 height:21
		checkbox chk3 "Allow auto render" pos:[160,123] width:105 height:19
		GroupBox grp2 "Enviroment" pos:[5,7] width:325 height:80
		GroupBox grp3 "Materials" pos:[6,194] width:133 height:140
		checkbox chk5 "Reproduce Wc3 materials" pos:[18,219] width:105 height:29 checked:true
		GroupBox grp4 "Render Options" pos:[154,99] width:175 height:163
		button btn2 "?" pos:[276,121] width:28 height:21
		radiobuttons rdo1 "Render form" pos:[168,150] width:108 height:62 enabled:false labels:#("Current frame", "Active segment", "Selected segment") columns:1
		checkbox chk6 "Save to file" pos:[167,216] width:117 height:19 enabled:false
		button btn3 "..." pos:[166,239] width:23 height:17 enabled:false toolTip:""
		edittext edt1 "" pos:[194,238] width:126 height:18 enabled:false
		spinner spn1 "" pos:[85,263] width:29 height:16 range:[1,16,1] type:#integer
		label lbl1 "Team Color:" pos:[16,264] width:63 height:14
		colorPicker cp4 "" pos:[28,286] width:29 height:22 enabled:false color:(color 255 0 0)
		radioButtons rdo2 "Lighting" pos:[17,28] width:294 height:46 labels:#("3ds max", "Wc3 Unshaded", "Wc3 Daylight", "Wc3 Nighlight") default:2 columns:3
		on btn1 pressed do
		(
			NeoDexUpdateTeamColor (spn1.value as integer)
			if not gmax then
				if Wc3RenderAuto then render () else Wc3Render ()
			else
				messagebox "The renderer is not supported for gmax, it will however, change teamcolors in your scene" beep:false
		)
		on chk3 changed newState do
		(
			if (not gmax) then
			(
				if newState then
				(
					callbacks.removeScripts #preRender id:#NeoDexRender
					callbacks.addScript #preRender "preRenderWc3 ()" id:#NeoDexRender
					callbacks.removeScripts #postRender id:#NeoDexRender
					callbacks.addScript #postRender "postRenderWc3 ()" id:#NeoDexRender
				)
				else
				(
					callbacks.removeScripts #preRender id:#NeoDexRender
					callbacks.removeScripts #postRender id:#NeoDexRender
				)
				Wc3RenderAuto = newState
			)
		)
		on btn2 pressed do
		(
			MessageBox (
				"Allow auto render will just apply wc3 settings whenever you render the scene in 3dsmax.\n" + \
				"This way you can combine wc3 rendering with other render settings in 3ds max. It also allows you to do " + \
				"neodex rendering by hitting F9."
			)
		)
		on spn1 changed newState do
		(
			cp4.color = NeoDexWc3MaterialTeamColors[newState]
		)
		on rdo2 changed newState do
		(
			Wc3LightState = newState
		)
	)
	--Main = newrolloutfloater ("NeoDex Renderer" + neoDexRDVersion) 175 215
	--addrollout optionsRoll Main

	createDialog optionsRoll

	optionsRoll.chk3.checked = Wc3RenderAuto
	optionsRoll.rdo2.state = Wc3LightState
	optionsRoll.cp4.color = NeoDexWc3MaterialTeamColors[NeoDexTeamColor]
	optionsRoll.spn1.value = NeoDexTeamColor
	
)
