
macroscript NeoDex_Vertex_Animation
    buttonText:"Vertex Animation Converter"
    category:"NeoDex Toolkit"
	internalCategory:"Converters" 
(
    local vaversion = "1.1"
	local Victim
	local Objective
	local BoneArray
	local KeyReduce = false
	local Start_frame = 0
	local End_frame = 100
	local Interp = 5
	local IsSession
	local session = undefined
	local SessionLbl
	local VAbakerd
	local gmax = (cylgizmo == undefined)
	fn IsMesh o = (return classOf o == Editable_mesh)
	
	fn CleanKeys obj =
	(
		s = Start_frame as time
		en = End_frame as time
		k = obj.pos.controller.keys
		for c = k.count to 1 by -1 do
		(
			if k[c].time >= s and k[c].time <= en then deletekey k c
		)
	)
	
	fn MakeSessionID = 
		if (not gmax) then
			((genClassID returnValue:true) as string)
		else
			((random 1 1000000) as string)
	
	fn IsPoint m = classof m == Point
	
	fn LoadSession m =
	(
		id = getUserProp m "VASession"
		Objective = undefined
		if id != undefined then
		(
			BoneArray = #()
			i = getUserProp m "VAItems"
			for o in Helpers do
			(
				if IsPoint o then
				(
					if (getUserProp o "VASession") == id then append BoneArray o
				)
			)
			for o in Geometry do
			(
				if IsMesh o then
				(
					if (getUserProp o "VAObject") == 1 and (getUserProp o "VASession") == session then
					(
						Objective = o
					)
				)
			)
			session = id
			if BoneArray.count != i and Objective == undefined then
			(
				IsSession = false
				SessionLbl.caption  = "Non Existant"
				VAbakerd.state = 2
			)
			else
			(
				if BoneArray.count != i or Objective == undefined then
				(
					IsSession = false
					SessionLbl.caption  = "Incomplete"
					VAbakerd.state = 2
				)
				else
				(
					IsSession = true
					SessionLbl.caption  = "Loaded"
					VAbakerd.state = 1
				)
			)
		)
		else
		(
			IsSession = false
		)
	)
	
	fn BakeSession tresshold keyreduction AddSE Clean =
	(
		undo on
		(
			disableSceneRedraw()
			max modify mode
			verts = Victim.verts
			if Clean == false then for o in BoneArray do CleanKeys o
			i = Start_frame
			with animate on
			(
				while i <= End_frame do
				(
					at time i for x = 1 to BoneArray.count do
					(
						BoneArray[x].pos = verts[x].pos
					)
					i += Interp
				)
			)
			if keyreduction == true then
			(
				q = Start_frame as time
				w = End_frame as time
				t = Interp as time
				for x = 1 to BoneArray.count do reduceKeys BoneArray[x].pos.controller tresshold t (interval q w)
				if AddSE == true then
				(
					with animate on
					(
						for x = 1 to BoneArray.count do
						(
							at time Start_frame BoneArray[x].pos = verts[x].pos
							at time End_frame BoneArray[x].pos = verts[x].pos
						)
					)
				)
			)
			enableSceneRedraw()
			i = 0
			messageBox "Done!"
		)
	)
	
	fn GenerateAnim tresshold keyreduction AddSE =
	(
		disableSceneRedraw()
		max modify mode
		m = copy Victim
		select m
		if IsSession != true then
		(
			session = MakeSessionID()
			setUserProp Victim "VASession" session
			setUserProp m "VASession" session
			setUserProp m "VAObject" 1
		)
		Objective = m
		m.name = ("VA" + Victim.name)
		at time Start_frame
		(
			collapseStack m
			deleteKeys m
		)
		sk = skin()
		addModifier m sk
		z = m.verts
		BoneArray = #()
		verts = Victim.verts
		at time 0f for s = 1 to verts.count do
			(
				b = point pos:verts[s].pos
				b.pos.controller = linear_position()
				b.name = "VABone" + (s as string)
				setUserProp b "VASession" session
				setUserProp b "VAId" s
				skinOps.addBone sk b 0
				sk.cross_radius = 1.0
				append BoneArray b
				with animate on b.pos = b.pos
			)
		setUserProp Victim "VAItems" BoneArray.count
		i = Start_frame
		with animate on
		(
			while i <= End_frame do
			(
				at time i for x = 1 to BoneArray.count do
				(
					BoneArray[x].pos = verts[x].pos
				)
				i += Interp
			)
		)
		if keyreduction == true then
		(
			q = Start_frame as time
			w = End_frame as time
			t = Interp as time
			for x = 1 to BoneArray.count do reduceKeys BoneArray[x].pos.controller tresshold t (interval q w)
			if AddSE == true then
			(
				with animate on
				(
					for x = 1 to BoneArray.count do
					(
						at time Start_frame BoneArray[x].pos = verts[x].pos
						at time End_frame BoneArray[x].pos = verts[x].pos
					)
				)
			)
		)
		IsSession = true
		SessionLbl.caption  = "Loaded"
		VAbakerd.state = 1
		enableSceneRedraw()
		i = 0
		at time 0f
		(
			try for i = 1 to verts.count do skinOps.SetVertexWeights sk i i 1.0 catch()
			messageBox "Done!"
		)
	)
	fn CleanSession =
	(
		delete BoneArray
		delete Objective
		BoneArray = undefined
		Objective = undefined
		session = undefined
		IsSession = false
		setUserProp Victim "VASession" undefined
		setUserProp Victim "VAItems" undefined
		SessionLbl.caption  = "Non Existant"
	)
	rollout aboutroll "About" width:234 height:116
	(
		groupBox grp1 "About" pos:[5,12] width:221 height:93
		label lbl1 "VANeoDex has been created by BlinkBoy For the powerful set of NeoDex Tools" pos:[17,33] width:198 height:33
		label lbl2 "This version had been finished on: 05/01/2009" pos:[19,71] width:202 height:29
	)
	rollout mainroll "VA Converter" width:245 height:515
	(
		GroupBox grp1 "NeoDex VA Converter" pos:[10,2] width:224 height:502
		spinner start "Start: " pos:[76,37] width:85 height:16 range:[0,999999,0] type:#integer scale:1
		spinner End "End:  " pos:[76,61] width:85 height:16 range:[0,999999,100] type:#integer scale:1
		spinner Interin "Interp: " pos:[76,81] width:85 height:16 range:[1,100,5] type:#integer scale:1
		pickbutton btn1 "Pick Object" pos:[95,112] width:104 height:28 filter:IsMesh
		button btn2 "Do the job!" pos:[71,377] width:104 height:28
		button btn10 "About" pos:[73,442] width:101 height:29
		GroupBox grp3 "Optimization" pos:[36,177] width:172 height:94
		checkbox chk1 "Apply Key Reduction" pos:[57,203] width:130 height:16
		spinner spn7 "Threshold" pos:[60,224] width:112 height:16 range:[0,100,0.5] scale:0.05
		GroupBox grp4 "Settings" pos:[36,21] width:172 height:152
		checkbox chk2 "Add Starting and Ending Keys" pos:[42,244] width:162 height:19
		label lbl1 "Object:" pos:[48,117] width:38 height:17
		GroupBox grp6 "Information" pos:[33,421] width:172 height:66
		GroupBox grp5 "Baking" pos:[34,277] width:172 height:134
		radiobuttons rdo1 "Baking type:" pos:[68,291] width:118 height:46 labels:#("Rebake last session", "Bake new session")
		checkbox chk3 "Don't clean prexisting keys in interval" pos:[54,342] width:139 height:29
		label lbl2 "Session: " pos:[49,147] width:49 height:18
		label lbl3 "Not Loaded" pos:[103,147] width:88 height:15
		on btn1 picked obj do
		( 
			if obj != undefined do
			(
				Victim = obj
				btn1.text = obj.name
				LoadSession Victim
			)
		)
		on btn2 pressed do
		(
			Start_frame = start.value
			End_frame = end.value
			Interp = Interin.value
			if Victim != undefined then
			(
				if start.value < end.value then
				(
					if IsSession == true then
					(
						if rdo1.state == 1 then BakeSession spn7.value chk1.checked chk2.checked  chk3.checked else
						(
							if (queryBox "By starting a new baking session, you are erasing the old one.\n\t Are you sure that you want to continue?"  beep:true)  == true then
							(
								CleanSession()
								GenerateAnim spn7.value chk1.checked chk2.checked
							)
							else messageBox "Nothing happens then!"
						)
					)
					else GenerateAnim spn7.value chk1.checked chk2.checked
				)
				else messageBox "Start Interval can't be higher or equal to the End!" beep:true
			)
			else messageBox "You must select a target object!" beep:true
		)
		on btn10 pressed do
		(
			createDialog aboutroll
		)
	)
	SessionLbl = mainroll.controls[19] --label3
	VAbakerd= mainroll.controls[16] --rd1
	--VAbakerd.state = 1
	Main = newrolloutfloater ("NeoDex VA Converter " + vaversion) 250 540
	addrollout mainroll Main
)