
plugin Helper Wc3CollisionSphere
name:"CollisionSphere" 
classID:#(0xb945647, 0x61c1bb70)
category:"Warcraft 3 Systems" 
extends:dummy 
(
	local lastRadius, meshObj
	parameters pblock rollout:params
	(
		radius type:#float animatable:true ui:amount default:1.0
	)
	rollout params "Collision Sphere Parameters"
	(
		Spinner amount "Radius:" range:[0, 1e9, 30]
	)
	on getDisplayMesh do
	(
		if (meshObj == undefined) do 
		(
			meshObj = createInstance sphere radius:radius
			lastRadius = radius
		)
		if radius != lastRadius do 
		(
			meshObj.radius = radius
			lastRadius = radius
		)
		meshObj.mesh
	)
	tool create 
	( 
		on mousePoint click do 
		(
			case click of
			(
				1: coordsys grid (nodeTM.translation = gridPoint)
			)
		)
		on mouseMove click do
		(
			case click of
			(
				2: (radius = abs(gridDist.y))
				3: (#stop)
			)
		)
	)
)

plugin Helper Wc3CollisionBox
name:"CollisionBox" 
classID:#(0x51e76dc0, 0x471f81a5)
category:"Warcraft 3 Systems" 
extends:dummy 
(
	local lastLength, lasHeight, lastWidth, meshObj
	parameters pblock rollout:params
	(
		length type:#float animatable:true ui:amount1 default:1.0
		width type:#float animatable:true ui:amount2 default:1.0
		height type:#float animatable:true ui:amount3 default:1.0
	)
	rollout params "Collision Box Parameters"
	(
		Spinner amount1 "Length:" range:[0, 1e9, 30]
		Spinner amount2 "Width:" range:[0, 1e9, 30]
		Spinner amount3 "Height:" range:[0, 1e9, 30]
	)
	on getDisplayMesh do
	(
		if (meshObj == undefined) do 
		(
			meshObj = createInstance box length:length \
			width:width height:height
			lastLength = length
			lastWidth = width
			lastHeight = height
		)
		if length != lastLength do 
		(
			meshObj.length = length
			lastLength = length
		)
		if width != lastWidth do 
		(
			meshObj.width = width
			lastWidth = width
		)
		if height != lasHeight do 
		(
			meshObj.height = height
			lastHeight = height
		)
		meshObj.mesh
	)
	tool create 
	( 
		on mousePoint click do 
		(
			case click of
			(
				1: coordsys grid (nodeTM.translation = gridPoint)
			)
		)
		on mouseMove click do
		(
			case click of
			(
				2: (
					length = abs(gridDist.y)
					width = abs(gridDist.x)
				)
				3: (height = abs(gridDist.z))
				4: (#stop)
			)
		)
	)
)
