global NeoDexWc3MaterialTeamGlowTextures = #()
global NeoDexWc3MaterialTeamColors = #(color 255 3 3, color 0 66 255, color 28 230 185, color 84 0 129, color 255 252 0, color 254 138 14, color 32 192 0, color 229 91 176, color 149 150 151, color 126 191 241, color 16 98 70, color 78 42 4, color 40 40 40, color 40 40 40, color 40 40 40, color 40 40 40)
global NeoDexTeamColor = 1
fn NeoDexGetTeamGlowFiles =
(
	local dir = (getDir #maxRoot) + "maps\\Neodex\\TeamGlow\\"
	local files = getFiles (dir + "*.tga")
	sort files
	files
)

fn NeoDexGenerateTeamGlows =
(
	files = NeoDexGetTeamGlowFiles ()
	NeoDexWc3MaterialTeamGlowTextures = #()
	if files.count == 16 then
	(
		for f in files do
		(
			local tmp = BitmapTexture ()
			tmp.fileName = f
			tmp.coords.V_Tile = false
			tmp.coords.U_Tile = false
			tmp.monoOutput = 1
			append NeoDexWc3MaterialTeamGlowTextures tmp
		)
	)
	else
		format "%" "NeoDex Load Exception: The teamglow files were not found" to:listener
)

--NeoDexGenerateTeamGlows ()

callbacks.removeScripts #postSystemStartup id:#NeoDexMaterials
callbacks.addScript #postSystemStartup "NeoDexGenerateTeamGlows ()" id:#NeoDexMaterials

global NeoDexMaterials = #()

fn NeoDexUpdateTeamColor teamColor =
(
	if (teamcolor > 0 and teamcolor < 17) then
	(
		NeoDexTeamColor = teamcolor
		for m in NeoDexMaterials do
			m.retexture = m.retexture
	)
)

fn NeoDexResetMaterials = NeoDexMaterials = #()

callbacks.removeScripts #systemPreNew id:#NeoDexMaterials
callbacks.removeScripts #systemPreReset id:#NeoDexMaterials
callbacks.removeScripts #filePreOpen id:#NeoDexMaterials
callbacks.addScript #systemPreNew "NeoDexResetMaterials ()" id:#NeoDexMaterials
callbacks.addScript #systemPreReset "NeoDexResetMaterials ()" id:#NeoDexMaterials
callbacks.addScript #filePreOpen "NeoDexResetMaterials ()" id:#NeoDexMaterials